<?php

// handels moc and attribute descriptors of one MOC

class MocDescriptor
{
    private $mocd;
    private $atdcs;
    
    function __construct(int $mocid, array $mocd, array $atdcs) {
        $this->mocd = $mocd[$mocid];
        $this->atdcs = array();
        $int_cls_name = $this->mocd["intern"];
        foreach ($atdcs as $atdc) {
            if ($atdc["moc"] == $int_cls_name) $this->atdcs[] = $atdc;
        }
    }
    
    function getAtdcs() {
        return $this->atdcs;
    }
    function getExtern() {
        return $this->mocd["extern"];
    }
    function getIntern() {
        return $this->mocd["intern"];
    }
    function getIntAttName(string $ext_att_name) {
        foreach ($this->atdcs as $atdc) {
            if ($atdc["extern"] == $ext_att_name) return $atdc["intern"];
        }
    }
    function getMocd() {
        return $this->mocd;
    }
}

